'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.getReducer = getReducer;
exports.getStore = getStore;
exports.setStore = setStore;
exports.addReducer = addReducer;

function _interopExportWildcard(obj, defaults) { var newObj = defaults({}, obj); delete newObj['default']; return newObj; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

require('babel/polyfill');

var _redux = require('redux');

var _objectPath = require('object-path');

var _lodashCamelcase = require('lodash.camelcase');

var _lodashCamelcase2 = _interopRequireDefault(_lodashCamelcase);

var _libWalkObjectJs = require('./lib/walkObject.js');

var _libWalkObjectJs2 = _interopRequireDefault(_libWalkObjectJs);

var store = undefined;
var reducer = function reducer(state, action) {
  return state;
};

var reducers = {};
var ActionTypes = {};
var ActionCreators = {};

exports.ActionTypes = ActionTypes;
exports.actions = ActionTypes;
exports.actionTypes = ActionTypes;
exports.types = ActionTypes;
exports.ActionCreators = ActionCreators;
exports.creators = ActionCreators;
exports.create = ActionCreators;

function getReducer() {
  return reducer;
}

function updateReducer() {
  reducer = (0, _redux.combineReducers)(reducers);
  store.replaceReducer(reducer);
}

function updateActionCreator(ActionCreator) {
  if (typeof ActionCreator !== 'function') return ActionCreator;
  if (!store.dispatch) return ActionCreator;

  ActionCreator.bound = (0, _redux.bindActionCreators)(ActionCreator, store.dispatch);
  return ActionCreator;
}

function updateActionCreators() {
  (0, _libWalkObjectJs2['default'])(ActionCreators, updateActionCreator);
}

function getStore() {
  return store;
}

function setStore(newStore) {
  store = newStore;
  updateReducer();
  updateActionCreators();
  return newStore;
}

function addReducer(key, newReducer) {
  (0, _objectPath.set)(reducers, key, newReducer);
  updateReducer();
}

function addActionType(key) {
  var value = arguments.length <= 1 || arguments[1] === undefined ? key : arguments[1];
  var creator = arguments.length <= 2 || arguments[2] === undefined ? function () {
    return { type: value };
  } : arguments[2];
  return (function () {
    var create = undefined;
    var val = undefined;
    if (typeof key !== 'string') throw new Error('Key must be a string.');
    if (typeof value === 'function') {
      create = value;
      val = key;
    } else {
      val = value;
      create = creator;
    }
    if (typeof val !== 'string') throw new Error('Value must be a string.');
    var createKey = (0, _lodashCamelcase2['default'])(key);
    var constKey = key.toUpperCase().replace(' ', '_');

    if (ActionCreators[createKey]) return ActionCreators[createKey];

    create.bound = updateActionCreator(create);

    ActionTypes[constKey] = val;
    ActionCreators[createKey] = create;

    return create;
  })();
}
exports.addActionType = addActionType;
exports.addType = addActionType;
exports.ActionType = addActionType;

store = (0, _redux.createStore)(getReducer());

_defaults(exports, _interopExportWildcard(_redux, _defaults));