/**
 * Created by Ari on 8/27/15.
 */
'use strict';

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _walkObjectJs = require('./walkObject.js');

var _walkObjectJs2 = _interopRequireDefault(_walkObjectJs);

var _chai = require('chai');

describe('walkObject', function () {
  it('should walk the object recursively', function () {
    var obj = {
      propA: 1,
      propB: 'thing',
      propC: ['a', 'b', 'c'],
      propD: {
        thingA: 'pizza',
        thingB: {
          pasta: true
        },
        thingC: ['x', 'y', 'z'],
        thingD: false
      }
    };
    var expectedItems = [1, 'thing', 'a', 'b', 'c', 'pizza', true, 'x', 'y', 'z', false];
    var actualItems = [];

    var handler = function handler(thing) {
      actualItems.push(thing);
      return thing;
    };

    (0, _walkObjectJs2['default'])(obj, handler);
    (0, _chai.expect)(actualItems).to.deep.equal(expectedItems);
  });
});